/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ac.bg.fon.silab.jpa.example1.main;

import java.util.logging.Level;
import java.util.logging.Logger;
import rs.ac.bg.fon.silab.jpa.example1.domen.BussinessEntity;
import rs.ac.bg.fon.silab.jpa.example1.domen.City;
import rs.ac.bg.fon.silab.jpa.example1.domen.Company;
import rs.ac.bg.fon.silab.jpa.example1.domen.ContactAddress;
import rs.ac.bg.fon.silab.jpa.example1.domen.ContactAddressType;
import rs.ac.bg.fon.silab.jpa.example1.domen.PersonalEntity;
import rs.ac.bg.fon.silab.jpa.example1.repository.JPARepository;

/**
 *
 * @author FON
 */
public class Main {

    public static void main(String[] args) {
//        saveCity();
//          saveCompany();
        //          findCity(11000l);
        //updateCompany();
        saveBussinessEntity();

    }

    private static void saveCity() {
        JPARepository jpaRepo = new JPARepository();
        City city = new City(11000l, "Novi Beograd");

        try {
            jpaRepo.saveCity(city);

        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
    }

    private static void saveCompany() {
        JPARepository jpaRepo = new JPARepository();
        Company company = new Company();
        company.setName("FON");
        company.setAddress("Jove Ilica 154");
        company.setVat("vat1");
        company.setIdentNumber("ident6");
        company.setCity(new City(13000l, "Pancevo"));

        //dodaj kontakt adrese
        ContactAddress phone = new ContactAddress();
        phone.setValue("011/3950876");
        phone.setContactAddressType(ContactAddressType.PHONE_NUMBER);
        phone.setCompany(company);

        ContactAddress webAddress = new ContactAddress();
        webAddress.setValue("fon.bg.ac.rs");
        webAddress.setContactAddressType(ContactAddressType.WEB_ADDRESS);
        webAddress.setCompany(company);

        company.getContactAddressList().add(phone);
        company.getContactAddressList().add(webAddress);
        try {
            jpaRepo.saveCompany(company);
            System.out.println("Company has been saved!");
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private static void findCity(Long code) {
        JPARepository jpaRepo = new JPARepository();
        City city = jpaRepo.findCity(code);
        System.out.println(city);
        for (Company company : city.getCompanyList()) {
            System.out.println(company);
        }
    }

    private static void updateCompany() {
        JPARepository jpaRepo = new JPARepository();
        Company company = new Company();
        company.setCompanyID(7l);
        company.setName("FON-7");
        company.setAddress("Jove Ilica 154");
        company.setVat("vat7");
        company.setIdentNumber("ident7");
        company.setCity(new City(13000l, "Pancevo"));

        //dodaj kontakt adrese
        ContactAddress phone = new ContactAddress();
        phone.setValue("neki@email.bg.ac.rs");
        phone.setContactAddressType(ContactAddressType.EMAIL);
        phone.setCompany(company);

        ContactAddress webAddress = new ContactAddress();
        webAddress.setValue("fon.bg.ac.rs");
        webAddress.setContactAddressType(ContactAddressType.WEB_ADDRESS);
        webAddress.setCompany(company);

        company.getContactAddressList().add(phone);
        company.getContactAddressList().add(webAddress);
        try {
            jpaRepo.updateCompany(company);
            System.out.println("Company has been updated!");
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private static void saveBussinessEntity() {
        JPARepository jpaRepo = new JPARepository();
        PersonalEntity bussinessEntity = new PersonalEntity();
        bussinessEntity.setFirstName("Zika");
        bussinessEntity.setLastName("Zikic");
        jpaRepo.saveBussinessEntity(bussinessEntity);
    }
}
